/**
 * 
 *
 * Generated by <a href="http://enunciate.webcohesion.com">Enunciate</a>.
 */
 
/**
 * UMD load definition that supports AMD, CommonJS and browser globals.
 * https://github.com/umdjs/umd/blob/992cc0d071b7ebcd7feaad2a5349bdbeab09a0fe/commonjsStrict.js
 */
(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['exports'], factory);
  } else if (typeof exports === 'object') {
    // CommonJS
    factory(exports);
  } else {
    // Browser globals
    factory(root.javascriptClient = {});
  }
}(this, function (exports) {
 
 'use strict';
 

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Openvpms.Booking.Domain');
exports.Org.Openvpms.Booking.Domain.Resource = class {

    /**
     * Constructs a Resource from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['id'] !== 'undefined') {
            this.id = o['id'];
        }
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
    }

    /**
     * the identifier
     *
     * @return integer
     */
    getId() {
        return this.id;
    }

    /**
     * the identifier
     *
     * @param integer id
     */
    setId(id) {
        this.id = id;
    }
    /**
     * the name
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * the name
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }

    /**
     * Returns a JSON object for this Resource
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.id !== 'undefined') {
            json['id'] = this.id;
        }
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Openvpms.Booking.Domain');
exports.Org.Openvpms.Booking.Domain.FreeBusy = class {

    /**
     * Constructs a FreeBusy from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.free = [];
        if (o['free']) {
            o['free'].forEach(function(x, i){
                self.free[i] = new exports.Org.Openvpms.Booking.Domain.Range(x);
            });
        }
        this.busy = [];
        if (o['busy']) {
            o['busy'].forEach(function(x, i){
                self.busy[i] = new exports.Org.Openvpms.Booking.Domain.Range(x);
            });
        }
    }

    /**
     * the free ranges
     *
     * @return Org.Openvpms.Booking.Domain.Range[]
     */
    getFree() {
        return this.free;
    }

    /**
     * the free ranges
     *
     * @param Org.Openvpms.Booking.Domain.Range[] free
     */
    setFree(free) {
        this.free = free;
    }
    /**
     * the busy ranges
     *
     * @return Org.Openvpms.Booking.Domain.Range[]
     */
    getBusy() {
        return this.busy;
    }

    /**
     * the busy ranges
     *
     * @param Org.Openvpms.Booking.Domain.Range[] busy
     */
    setBusy(busy) {
        this.busy = busy;
    }

    /**
     * Returns a JSON object for this FreeBusy
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.free) {
            json['free'] = [];
            this.free.forEach(function(x, i){
                json['free'][i] = x.toJSON();
            });
        }
        if (this.busy) {
            json['busy'] = [];
            this.busy.forEach(function(x, i){
                json['busy'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Openvpms.Booking.Domain');
exports.Org.Openvpms.Booking.Domain.Range = class {

    /**
     * Constructs a Range from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['start'] !== 'undefined') {
            this.start = o['start'];
        }
        if (typeof o['end'] !== 'undefined') {
            this.end = o['end'];
        }
    }

    /**
     * the start of the range
     *
     * @return integer
     */
    getStart() {
        return this.start;
    }

    /**
     * the start of the range
     *
     * @param integer start
     */
    setStart(start) {
        this.start = start;
    }
    /**
     * the end of the range
     *
     * @return integer
     */
    getEnd() {
        return this.end;
    }

    /**
     * the end of the range
     *
     * @param integer end
     */
    setEnd(end) {
        this.end = end;
    }

    /**
     * Returns a JSON object for this Range
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.start !== 'undefined') {
            json['start'] = this.start;
        }
        if (typeof this.end !== 'undefined') {
            json['end'] = this.end;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Openvpms.Booking.Domain');
exports.Org.Openvpms.Booking.Domain.Booking = class {

    /**
     * Constructs a Booking from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['location'] !== 'undefined') {
            this.location = o['location'];
        }
        if (typeof o['schedule'] !== 'undefined') {
            this.schedule = o['schedule'];
        }
        if (typeof o['appointmentType'] !== 'undefined') {
            this.appointmentType = o['appointmentType'];
        }
        if (typeof o['start'] !== 'undefined') {
            this.start = o['start'];
        }
        if (typeof o['end'] !== 'undefined') {
            this.end = o['end'];
        }
        if (typeof o['title'] !== 'undefined') {
            this.title = o['title'];
        }
        if (typeof o['firstName'] !== 'undefined') {
            this.firstName = o['firstName'];
        }
        if (typeof o['lastName'] !== 'undefined') {
            this.lastName = o['lastName'];
        }
        if (typeof o['email'] !== 'undefined') {
            this.email = o['email'];
        }
        if (typeof o['phone'] !== 'undefined') {
            this.phone = o['phone'];
        }
        if (typeof o['mobile'] !== 'undefined') {
            this.mobile = o['mobile'];
        }
        if (typeof o['patientName'] !== 'undefined') {
            this.patientName = o['patientName'];
        }
        if (typeof o['notes'] !== 'undefined') {
            this.notes = o['notes'];
        }
    }

    /**
     * the practice location identifier
     *
     * @return integer
     */
    getLocation() {
        return this.location;
    }

    /**
     * the practice location identifier
     *
     * @param integer location
     */
    setLocation(location) {
        this.location = location;
    }
    /**
     * the schedule identifier
     *
     * @return integer
     */
    getSchedule() {
        return this.schedule;
    }

    /**
     * the schedule identifier
     *
     * @param integer schedule
     */
    setSchedule(schedule) {
        this.schedule = schedule;
    }
    /**
     * the appointment type
     *
     * @return integer
     */
    getAppointmentType() {
        return this.appointmentType;
    }

    /**
     * the appointment type
     *
     * @param integer appointmentType
     */
    setAppointmentType(appointmentType) {
        this.appointmentType = appointmentType;
    }
    /**
     * the appointment start time
     *
     * @return integer
     */
    getStart() {
        return this.start;
    }

    /**
     * the appointment start time
     *
     * @param integer start
     */
    setStart(start) {
        this.start = start;
    }
    /**
     * the appointment end time
     *
     * @return integer
     */
    getEnd() {
        return this.end;
    }

    /**
     * the appointment end time
     *
     * @param integer end
     */
    setEnd(end) {
        this.end = end;
    }
    /**
     * the customer title
     *
     * @return string
     */
    getTitle() {
        return this.title;
    }

    /**
     * the customer title
     *
     * @param string title
     */
    setTitle(title) {
        this.title = title;
    }
    /**
     * the customer first name
     *
     * @return string
     */
    getFirstName() {
        return this.firstName;
    }

    /**
     * the customer first name
     *
     * @param string firstName
     */
    setFirstName(firstName) {
        this.firstName = firstName;
    }
    /**
     * the customer last name
     *
     * @return string
     */
    getLastName() {
        return this.lastName;
    }

    /**
     * the customer last name
     *
     * @param string lastName
     */
    setLastName(lastName) {
        this.lastName = lastName;
    }
    /**
     * the customer email
     *
     * @return string
     */
    getEmail() {
        return this.email;
    }

    /**
     * the customer email
     *
     * @param string email
     */
    setEmail(email) {
        this.email = email;
    }
    /**
     * the customer phone number. May be null
     *
     * @return string
     */
    getPhone() {
        return this.phone;
    }

    /**
     * the customer phone number. May be null
     *
     * @param string phone
     */
    setPhone(phone) {
        this.phone = phone;
    }
    /**
     * the customer mobile number. May be null
     *
     * @return string
     */
    getMobile() {
        return this.mobile;
    }

    /**
     * the customer mobile number. May be null
     *
     * @param string mobile
     */
    setMobile(mobile) {
        this.mobile = mobile;
    }
    /**
     * the patient name
     *
     * @return string
     */
    getPatientName() {
        return this.patientName;
    }

    /**
     * the patient name
     *
     * @param string patientName
     */
    setPatientName(patientName) {
        this.patientName = patientName;
    }
    /**
     * the notes. May be null
     *
     * @return string
     */
    getNotes() {
        return this.notes;
    }

    /**
     * the notes. May be null
     *
     * @param string notes
     */
    setNotes(notes) {
        this.notes = notes;
    }

    /**
     * Returns a JSON object for this Booking
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.location !== 'undefined') {
            json['location'] = this.location;
        }
        if (typeof this.schedule !== 'undefined') {
            json['schedule'] = this.schedule;
        }
        if (typeof this.appointmentType !== 'undefined') {
            json['appointmentType'] = this.appointmentType;
        }
        if (typeof this.start !== 'undefined') {
            json['start'] = this.start;
        }
        if (typeof this.end !== 'undefined') {
            json['end'] = this.end;
        }
        if (typeof this.title !== 'undefined') {
            json['title'] = this.title;
        }
        if (typeof this.firstName !== 'undefined') {
            json['firstName'] = this.firstName;
        }
        if (typeof this.lastName !== 'undefined') {
            json['lastName'] = this.lastName;
        }
        if (typeof this.email !== 'undefined') {
            json['email'] = this.email;
        }
        if (typeof this.phone !== 'undefined') {
            json['phone'] = this.phone;
        }
        if (typeof this.mobile !== 'undefined') {
            json['mobile'] = this.mobile;
        }
        if (typeof this.patientName !== 'undefined') {
            json['patientName'] = this.patientName;
        }
        if (typeof this.notes !== 'undefined') {
            json['notes'] = this.notes;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Openvpms.Booking.Domain');
exports.Org.Openvpms.Booking.Domain.Location = class extends exports.Org.Openvpms.Booking.Domain.Resource {

    /**
     * Constructs a Location from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['timeZone'] !== 'undefined') {
            this.timeZone = o['timeZone'];
        }
    }

    /**
     * the time zone
     *
     * @return string
     */
    getTimeZone() {
        return this.timeZone;
    }

    /**
     * the time zone
     *
     * @param string timeZone
     */
    setTimeZone(timeZone) {
        this.timeZone = timeZone;
    }

    /**
     * Returns a JSON object for this Location
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.timeZone !== 'undefined') {
            json['timeZone'] = this.timeZone;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Openvpms.Booking.Domain');
exports.Org.Openvpms.Booking.Domain.AppointmentType = class extends exports.Org.Openvpms.Booking.Domain.Resource {

    /**
     * Constructs a AppointmentType from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['slots'] !== 'undefined') {
            this.slots = o['slots'];
        }
    }

    /**
     * the no. of slots
     *
     * @return integer
     */
    getSlots() {
        return this.slots;
    }

    /**
     * the no. of slots
     *
     * @param integer slots
     */
    setSlots(slots) {
        this.slots = slots;
    }

    /**
     * Returns a JSON object for this AppointmentType
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.slots !== 'undefined') {
            json['slots'] = this.slots;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Openvpms.Booking.Domain');
exports.Org.Openvpms.Booking.Domain.Schedule = class extends exports.Org.Openvpms.Booking.Domain.Resource {

    /**
     * Constructs a Schedule from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['slotSize'] !== 'undefined') {
            this.slotSize = o['slotSize'];
        }
    }

    /**
     * the slot size, in minutes
     *
     * @return integer
     */
    getSlotSize() {
        return this.slotSize;
    }

    /**
     * the slot size, in minutes
     *
     * @param integer slotSize
     */
    setSlotSize(slotSize) {
        this.slotSize = slotSize;
    }

    /**
     * Returns a JSON object for this Schedule
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.slotSize !== 'undefined') {
            json['slotSize'] = this.slotSize;
        }
        return json;
    }

}
  
  /**
   * Ensures that a namespace exists.
   */
  function ensureNamespace(namespace){
    var current = exports;
    namespace.split('.').forEach(function(name){
      if(typeof current[name] === 'undefined'){
        current[name] = {};
      }
      current = current[name];
    });
  }

}));

