<?php

/**
 *
 * 
 *
 * Generated by <a href="http://enunciate.webcohesion.com">Enunciate</a>.
 *
 */
 

namespace Org\Openvpms\Booking\Domain;

/**
 * (no documentation provided)
 */
class Resource
{

    /**
     * the identifier
     *
     * @var integer
     */
    private $id;

    /**
     * the name
     *
     * @var string
     */
    private $name;

    /**
     * Constructs a Resource from a (parsed) JSON hash
     *
     * @param mixed $o JSON array.
     */
    public function __construct($o = null)
    {
        $this->initFromArray($o);
    }

    /**
     * the identifier
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * the identifier
     *
     * @param integer $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }
    /**
     * the name
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * the name
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * Returns the associative array for this Resource
     *
     * @return array
     */
    public function toArray()
    {
        $a = array();
        if ($this->id) {
            $a["id"] = $this->id;
        }
        if ($this->name) {
            $a["name"] = $this->name;
        }
        return $a;
    }

    /**
     * Returns the JSON string for this Resource
     *
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Initializes this Resource from an associative array
     *
     * @param array $o
     */
    public function initFromArray($o)
    {
        if (isset($o['id'])) {
            $this->id = $o["id"];
        }
        if (isset($o['name'])) {
            $this->name = $o["name"];
        }
    }
}

namespace Org\Openvpms\Booking\Domain;

/**
 * (no documentation provided)
 */
class FreeBusy
{

    /**
     * the free ranges
     *
     * @var \Org\Openvpms\Booking\Domain\Range[]
     */
    private $free;

    /**
     * the busy ranges
     *
     * @var \Org\Openvpms\Booking\Domain\Range[]
     */
    private $busy;

    /**
     * Constructs a FreeBusy from a (parsed) JSON hash
     *
     * @param mixed $o JSON array.
     */
    public function __construct($o = null)
    {
        $this->initFromArray($o);
    }

    /**
     * the free ranges
     *
     * @return \Org\Openvpms\Booking\Domain\Range[]
     */
    public function getFree()
    {
        return $this->free;
    }

    /**
     * the free ranges
     *
     * @param \Org\Openvpms\Booking\Domain\Range[] $free
     */
    public function setFree($free)
    {
        $this->free = $free;
    }
    /**
     * the busy ranges
     *
     * @return \Org\Openvpms\Booking\Domain\Range[]
     */
    public function getBusy()
    {
        return $this->busy;
    }

    /**
     * the busy ranges
     *
     * @param \Org\Openvpms\Booking\Domain\Range[] $busy
     */
    public function setBusy($busy)
    {
        $this->busy = $busy;
    }
    /**
     * Returns the associative array for this FreeBusy
     *
     * @return array
     */
    public function toArray()
    {
        $a = array();
        if ($this->free) {
            $ab = array();
            foreach ($this->free as $i => $x) {
                $ab[$i] = $x->toArray();
            }
            $a['free'] = $ab;
        }
        if ($this->busy) {
            $ab = array();
            foreach ($this->busy as $i => $x) {
                $ab[$i] = $x->toArray();
            }
            $a['busy'] = $ab;
        }
        return $a;
    }

    /**
     * Returns the JSON string for this FreeBusy
     *
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Initializes this FreeBusy from an associative array
     *
     * @param array $o
     */
    public function initFromArray($o)
    {
        $this->free = array();
        if (isset($o['free'])) {
            foreach ($o['free'] as $i => $x) {
                $this->free[$i] = new \Org\Openvpms\Booking\Domain\Range($x);
            }
        }
        $this->busy = array();
        if (isset($o['busy'])) {
            foreach ($o['busy'] as $i => $x) {
                $this->busy[$i] = new \Org\Openvpms\Booking\Domain\Range($x);
            }
        }
    }
}

namespace Org\Openvpms\Booking\Domain;

/**
 * (no documentation provided)
 */
class Range
{

    /**
     * the start of the range
     *
     * @var integer
     */
    private $start;

    /**
     * the end of the range
     *
     * @var integer
     */
    private $end;

    /**
     * Constructs a Range from a (parsed) JSON hash
     *
     * @param mixed $o JSON array.
     */
    public function __construct($o = null)
    {
        $this->initFromArray($o);
    }

    /**
     * the start of the range
     *
     * @return integer
     */
    public function getStart()
    {
        return $this->start;
    }

    /**
     * the start of the range
     *
     * @param integer $start
     */
    public function setStart($start)
    {
        $this->start = $start;
    }
    /**
     * the end of the range
     *
     * @return integer
     */
    public function getEnd()
    {
        return $this->end;
    }

    /**
     * the end of the range
     *
     * @param integer $end
     */
    public function setEnd($end)
    {
        $this->end = $end;
    }
    /**
     * Returns the associative array for this Range
     *
     * @return array
     */
    public function toArray()
    {
        $a = array();
        if ($this->start) {
            $a["start"] = $this->start;
        }
        if ($this->end) {
            $a["end"] = $this->end;
        }
        return $a;
    }

    /**
     * Returns the JSON string for this Range
     *
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Initializes this Range from an associative array
     *
     * @param array $o
     */
    public function initFromArray($o)
    {
        if (isset($o['start'])) {
            $this->start = $o["start"];
        }
        if (isset($o['end'])) {
            $this->end = $o["end"];
        }
    }
}

namespace Org\Openvpms\Booking\Domain;

/**
 * (no documentation provided)
 */
class Booking
{

    /**
     * the practice location identifier
     *
     * @var integer
     */
    private $location;

    /**
     * the schedule identifier
     *
     * @var integer
     */
    private $schedule;

    /**
     * the appointment type
     *
     * @var integer
     */
    private $appointmentType;

    /**
     * the appointment start time
     *
     * @var integer
     */
    private $start;

    /**
     * the appointment end time
     *
     * @var integer
     */
    private $end;

    /**
     * the customer title
     *
     * @var string
     */
    private $title;

    /**
     * the customer first name
     *
     * @var string
     */
    private $firstName;

    /**
     * the customer last name
     *
     * @var string
     */
    private $lastName;

    /**
     * the customer email
     *
     * @var string
     */
    private $email;

    /**
     * the customer phone number. May be null
     *
     * @var string
     */
    private $phone;

    /**
     * the customer mobile number. May be null
     *
     * @var string
     */
    private $mobile;

    /**
     * the patient name
     *
     * @var string
     */
    private $patientName;

    /**
     * the notes. May be null
     *
     * @var string
     */
    private $notes;

    /**
     * Constructs a Booking from a (parsed) JSON hash
     *
     * @param mixed $o JSON array.
     */
    public function __construct($o = null)
    {
        $this->initFromArray($o);
    }

    /**
     * the practice location identifier
     *
     * @return integer
     */
    public function getLocation()
    {
        return $this->location;
    }

    /**
     * the practice location identifier
     *
     * @param integer $location
     */
    public function setLocation($location)
    {
        $this->location = $location;
    }
    /**
     * the schedule identifier
     *
     * @return integer
     */
    public function getSchedule()
    {
        return $this->schedule;
    }

    /**
     * the schedule identifier
     *
     * @param integer $schedule
     */
    public function setSchedule($schedule)
    {
        $this->schedule = $schedule;
    }
    /**
     * the appointment type
     *
     * @return integer
     */
    public function getAppointmentType()
    {
        return $this->appointmentType;
    }

    /**
     * the appointment type
     *
     * @param integer $appointmentType
     */
    public function setAppointmentType($appointmentType)
    {
        $this->appointmentType = $appointmentType;
    }
    /**
     * the appointment start time
     *
     * @return integer
     */
    public function getStart()
    {
        return $this->start;
    }

    /**
     * the appointment start time
     *
     * @param integer $start
     */
    public function setStart($start)
    {
        $this->start = $start;
    }
    /**
     * the appointment end time
     *
     * @return integer
     */
    public function getEnd()
    {
        return $this->end;
    }

    /**
     * the appointment end time
     *
     * @param integer $end
     */
    public function setEnd($end)
    {
        $this->end = $end;
    }
    /**
     * the customer title
     *
     * @return string
     */
    public function getTitle()
    {
        return $this->title;
    }

    /**
     * the customer title
     *
     * @param string $title
     */
    public function setTitle($title)
    {
        $this->title = $title;
    }
    /**
     * the customer first name
     *
     * @return string
     */
    public function getFirstName()
    {
        return $this->firstName;
    }

    /**
     * the customer first name
     *
     * @param string $firstName
     */
    public function setFirstName($firstName)
    {
        $this->firstName = $firstName;
    }
    /**
     * the customer last name
     *
     * @return string
     */
    public function getLastName()
    {
        return $this->lastName;
    }

    /**
     * the customer last name
     *
     * @param string $lastName
     */
    public function setLastName($lastName)
    {
        $this->lastName = $lastName;
    }
    /**
     * the customer email
     *
     * @return string
     */
    public function getEmail()
    {
        return $this->email;
    }

    /**
     * the customer email
     *
     * @param string $email
     */
    public function setEmail($email)
    {
        $this->email = $email;
    }
    /**
     * the customer phone number. May be null
     *
     * @return string
     */
    public function getPhone()
    {
        return $this->phone;
    }

    /**
     * the customer phone number. May be null
     *
     * @param string $phone
     */
    public function setPhone($phone)
    {
        $this->phone = $phone;
    }
    /**
     * the customer mobile number. May be null
     *
     * @return string
     */
    public function getMobile()
    {
        return $this->mobile;
    }

    /**
     * the customer mobile number. May be null
     *
     * @param string $mobile
     */
    public function setMobile($mobile)
    {
        $this->mobile = $mobile;
    }
    /**
     * the patient name
     *
     * @return string
     */
    public function getPatientName()
    {
        return $this->patientName;
    }

    /**
     * the patient name
     *
     * @param string $patientName
     */
    public function setPatientName($patientName)
    {
        $this->patientName = $patientName;
    }
    /**
     * the notes. May be null
     *
     * @return string
     */
    public function getNotes()
    {
        return $this->notes;
    }

    /**
     * the notes. May be null
     *
     * @param string $notes
     */
    public function setNotes($notes)
    {
        $this->notes = $notes;
    }
    /**
     * Returns the associative array for this Booking
     *
     * @return array
     */
    public function toArray()
    {
        $a = array();
        if ($this->location) {
            $a["location"] = $this->location;
        }
        if ($this->schedule) {
            $a["schedule"] = $this->schedule;
        }
        if ($this->appointmentType) {
            $a["appointmentType"] = $this->appointmentType;
        }
        if ($this->start) {
            $a["start"] = $this->start;
        }
        if ($this->end) {
            $a["end"] = $this->end;
        }
        if ($this->title) {
            $a["title"] = $this->title;
        }
        if ($this->firstName) {
            $a["firstName"] = $this->firstName;
        }
        if ($this->lastName) {
            $a["lastName"] = $this->lastName;
        }
        if ($this->email) {
            $a["email"] = $this->email;
        }
        if ($this->phone) {
            $a["phone"] = $this->phone;
        }
        if ($this->mobile) {
            $a["mobile"] = $this->mobile;
        }
        if ($this->patientName) {
            $a["patientName"] = $this->patientName;
        }
        if ($this->notes) {
            $a["notes"] = $this->notes;
        }
        return $a;
    }

    /**
     * Returns the JSON string for this Booking
     *
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Initializes this Booking from an associative array
     *
     * @param array $o
     */
    public function initFromArray($o)
    {
        if (isset($o['location'])) {
            $this->location = $o["location"];
        }
        if (isset($o['schedule'])) {
            $this->schedule = $o["schedule"];
        }
        if (isset($o['appointmentType'])) {
            $this->appointmentType = $o["appointmentType"];
        }
        if (isset($o['start'])) {
            $this->start = $o["start"];
        }
        if (isset($o['end'])) {
            $this->end = $o["end"];
        }
        if (isset($o['title'])) {
            $this->title = $o["title"];
        }
        if (isset($o['firstName'])) {
            $this->firstName = $o["firstName"];
        }
        if (isset($o['lastName'])) {
            $this->lastName = $o["lastName"];
        }
        if (isset($o['email'])) {
            $this->email = $o["email"];
        }
        if (isset($o['phone'])) {
            $this->phone = $o["phone"];
        }
        if (isset($o['mobile'])) {
            $this->mobile = $o["mobile"];
        }
        if (isset($o['patientName'])) {
            $this->patientName = $o["patientName"];
        }
        if (isset($o['notes'])) {
            $this->notes = $o["notes"];
        }
    }
}

namespace Org\Openvpms\Booking\Domain;

/**
 * (no documentation provided)
 */
class Location extends \Org\Openvpms\Booking\Domain\Resource
{

    /**
     * the time zone
     *
     * @var string
     */
    private $timeZone;

    /**
     * Constructs a Location from a (parsed) JSON hash
     *
     * @param mixed $o JSON array.
     */
    public function __construct($o = null)
    {
        $this->initFromArray($o);
    }

    /**
     * the time zone
     *
     * @return string
     */
    public function getTimeZone()
    {
        return $this->timeZone;
    }

    /**
     * the time zone
     *
     * @param string $timeZone
     */
    public function setTimeZone($timeZone)
    {
        $this->timeZone = $timeZone;
    }
    /**
     * Returns the associative array for this Location
     *
     * @return array
     */
    public function toArray()
    {
        $a = parent::toArray();
        if ($this->timeZone) {
            $a["timeZone"] = $this->timeZone;
        }
        return $a;
    }


    /**
     * Initializes this Location from an associative array
     *
     * @param array $o
     */
    public function initFromArray($o)
    {
        parent::initFromArray($o);
        if (isset($o['timeZone'])) {
            $this->timeZone = $o["timeZone"];
        }
    }
}

namespace Org\Openvpms\Booking\Domain;

/**
 * (no documentation provided)
 */
class AppointmentType extends \Org\Openvpms\Booking\Domain\Resource
{

    /**
     * the no. of slots
     *
     * @var integer
     */
    private $slots;

    /**
     * Constructs a AppointmentType from a (parsed) JSON hash
     *
     * @param mixed $o JSON array.
     */
    public function __construct($o = null)
    {
        $this->initFromArray($o);
    }

    /**
     * the no. of slots
     *
     * @return integer
     */
    public function getSlots()
    {
        return $this->slots;
    }

    /**
     * the no. of slots
     *
     * @param integer $slots
     */
    public function setSlots($slots)
    {
        $this->slots = $slots;
    }
    /**
     * Returns the associative array for this AppointmentType
     *
     * @return array
     */
    public function toArray()
    {
        $a = parent::toArray();
        if ($this->slots) {
            $a["slots"] = $this->slots;
        }
        return $a;
    }


    /**
     * Initializes this AppointmentType from an associative array
     *
     * @param array $o
     */
    public function initFromArray($o)
    {
        parent::initFromArray($o);
        if (isset($o['slots'])) {
            $this->slots = $o["slots"];
        }
    }
}

namespace Org\Openvpms\Booking\Domain;

/**
 * (no documentation provided)
 */
class Schedule extends \Org\Openvpms\Booking\Domain\Resource
{

    /**
     * the slot size, in minutes
     *
     * @var integer
     */
    private $slotSize;

    /**
     * Constructs a Schedule from a (parsed) JSON hash
     *
     * @param mixed $o JSON array.
     */
    public function __construct($o = null)
    {
        $this->initFromArray($o);
    }

    /**
     * the slot size, in minutes
     *
     * @return integer
     */
    public function getSlotSize()
    {
        return $this->slotSize;
    }

    /**
     * the slot size, in minutes
     *
     * @param integer $slotSize
     */
    public function setSlotSize($slotSize)
    {
        $this->slotSize = $slotSize;
    }
    /**
     * Returns the associative array for this Schedule
     *
     * @return array
     */
    public function toArray()
    {
        $a = parent::toArray();
        if ($this->slotSize) {
            $a["slotSize"] = $this->slotSize;
        }
        return $a;
    }


    /**
     * Initializes this Schedule from an associative array
     *
     * @param array $o
     */
    public function initFromArray($o)
    {
        parent::initFromArray($o);
        if (isset($o['slotSize'])) {
            $this->slotSize = $o["slotSize"];
        }
    }
}
