#
# 
#
# Generated by <a href="http://enunciate.webcohesion.com">Enunciate</a>.
#
require 'json'

# adding necessary json serialization methods to standard classes.
class Object
  def to_jaxb_json_hash
    return self
  end
  def self.from_json o
    return o
  end
end

class String
  def self.from_json o
    return o
  end
end

class Boolean
  def self.from_json o
    return o
  end
end

class Numeric
  def self.from_json o
    return o
  end
end

class Time
  #json time is represented as number of milliseconds since epoch
  def to_jaxb_json_hash
    return (to_i * 1000) + (usec / 1000)
  end
  def self.from_json o
    if o.nil?
      return nil
    else
      return Time.at(o / 1000, (o % 1000) * 1000)
    end
  end
end

class Array
  def to_jaxb_json_hash
    a = Array.new
    each { | _item | a.push _item.to_jaxb_json_hash }
    return a
  end
end

class Hash
  def to_jaxb_json_hash
    h = Hash.new
    each { | _key, _value | h[_key.to_jaxb_json_hash] = _value.to_jaxb_json_hash }
    return h
  end
end

module EnunciateHelpers
  LAMB_CLASS_AWARE = ->(_item) do
    java_clazz = _item['@class']
    clazz_array_parts = java_clazz.split('.')
    short_clazz = clazz_array_parts.pop
    clazz_package = clazz_array_parts.map do |e| e[0] = e.first.capitalize; e end.join("::")
    clazz = clazz_package + "::" + short_clazz
    Object.const_get(clazz).send(:from_json, _item)
  end
end


module Org

module Openvpms

module Booking

module Domain

  # (no documentation provided)
  class Resource 

    # the identifier
    attr_accessor :id
    # the name
    attr_accessor :name

    # the json hash for this Resource
    def to_jaxb_json_hash
      _h = {}
      _h['id'] = id.to_jaxb_json_hash unless id.nil?
      _h['name'] = name.to_jaxb_json_hash unless name.nil?
      return _h
    end

    # the json (string form) for this Resource
    def to_json
      to_jaxb_json_hash.to_json
    end

    #initializes this Resource with a json hash
    def init_jaxb_json_hash(_o)
        if !_o['id'].nil?
          _oa = _o['id']
            if(_oa.is_a? Hash)
              @id = EnunciateHelpers::LAMB_CLASS_AWARE.call(_oa) if _oa['@class']
              @id =  Bignum.from_json(_oa) unless _oa['@class']
            elsif (_oa.is_a? Array)
              #an array(of hashes hopefully) or scalar
              @id = Array.new
              _oa.each { | _item | 
                 if ((_item.nil? || _item['@class'].nil?)rescue true)
                   @id.push Bignum.from_json(_item)
                 else
                   @id.push EnunciateHelpers::LAMB_CLASS_AWARE.call(_item)
                 end
               }
            else
                @id = _oa
            end
          end
        if !_o['name'].nil?
          _oa = _o['name']
            if(_oa.is_a? Hash)
              @name = EnunciateHelpers::LAMB_CLASS_AWARE.call(_oa) if _oa['@class']
              @name =  String.from_json(_oa) unless _oa['@class']
            elsif (_oa.is_a? Array)
              #an array(of hashes hopefully) or scalar
              @name = Array.new
              _oa.each { | _item | 
                 if ((_item.nil? || _item['@class'].nil?)rescue true)
                   @name.push String.from_json(_item)
                 else
                   @name.push EnunciateHelpers::LAMB_CLASS_AWARE.call(_item)
                 end
               }
            else
                @name = _oa
            end
          end
    end

    # constructs a Resource from a (parsed) JSON hash
    def self.from_json(o)
      if o.nil?
        return nil
      else
        inst = new
        inst.init_jaxb_json_hash o
        return inst
      end
    end
  end

end

end

end

end

module Org

module Openvpms

module Booking

module Domain

  # (no documentation provided)
  class FreeBusy 

    # the free ranges
    attr_accessor :free
    # the busy ranges
    attr_accessor :busy

    # the json hash for this FreeBusy
    def to_jaxb_json_hash
      _h = {}
      if !free.nil?
        _ha = Array.new
        free.each { | _item | _ha.push _item.to_jaxb_json_hash }
        _h['free'] = _ha
      end
      if !busy.nil?
        _ha = Array.new
        busy.each { | _item | _ha.push _item.to_jaxb_json_hash }
        _h['busy'] = _ha
      end
      return _h
    end

    # the json (string form) for this FreeBusy
    def to_json
      to_jaxb_json_hash.to_json
    end

    #initializes this FreeBusy with a json hash
    def init_jaxb_json_hash(_o)
        if !_o['free'].nil?
          _oa = _o['free']
            if(_oa.is_a? Hash)
              @free = EnunciateHelpers::LAMB_CLASS_AWARE.call(_oa) if _oa['@class']
              @free =  Org::Openvpms::Booking::Domain::Range.from_json(_oa) unless _oa['@class']
            elsif (_oa.is_a? Array)
              #an array(of hashes hopefully) or scalar
              @free = Array.new
              _oa.each { | _item | 
                 if ((_item.nil? || _item['@class'].nil?)rescue true)
                   @free.push Org::Openvpms::Booking::Domain::Range.from_json(_item)
                 else
                   @free.push EnunciateHelpers::LAMB_CLASS_AWARE.call(_item)
                 end
               }
            else
                @free = _oa
            end
          end
        if !_o['busy'].nil?
          _oa = _o['busy']
            if(_oa.is_a? Hash)
              @busy = EnunciateHelpers::LAMB_CLASS_AWARE.call(_oa) if _oa['@class']
              @busy =  Org::Openvpms::Booking::Domain::Range.from_json(_oa) unless _oa['@class']
            elsif (_oa.is_a? Array)
              #an array(of hashes hopefully) or scalar
              @busy = Array.new
              _oa.each { | _item | 
                 if ((_item.nil? || _item['@class'].nil?)rescue true)
                   @busy.push Org::Openvpms::Booking::Domain::Range.from_json(_item)
                 else
                   @busy.push EnunciateHelpers::LAMB_CLASS_AWARE.call(_item)
                 end
               }
            else
                @busy = _oa
            end
          end
    end

    # constructs a FreeBusy from a (parsed) JSON hash
    def self.from_json(o)
      if o.nil?
        return nil
      else
        inst = new
        inst.init_jaxb_json_hash o
        return inst
      end
    end
  end

end

end

end

end

module Org

module Openvpms

module Booking

module Domain

  # (no documentation provided)
  class Range 

    # the start of the range
    attr_accessor :start
    # the end of the range
    attr_accessor :end

    # the json hash for this Range
    def to_jaxb_json_hash
      _h = {}
      _h['start'] = start.to_jaxb_json_hash unless start.nil?
      _h['end'] = end.to_jaxb_json_hash unless end.nil?
      return _h
    end

    # the json (string form) for this Range
    def to_json
      to_jaxb_json_hash.to_json
    end

    #initializes this Range with a json hash
    def init_jaxb_json_hash(_o)
        if !_o['start'].nil?
          _oa = _o['start']
            if(_oa.is_a? Hash)
              @start = EnunciateHelpers::LAMB_CLASS_AWARE.call(_oa) if _oa['@class']
              @start =  Time.from_json(_oa) unless _oa['@class']
            elsif (_oa.is_a? Array)
              #an array(of hashes hopefully) or scalar
              @start = Array.new
              _oa.each { | _item | 
                 if ((_item.nil? || _item['@class'].nil?)rescue true)
                   @start.push Time.from_json(_item)
                 else
                   @start.push EnunciateHelpers::LAMB_CLASS_AWARE.call(_item)
                 end
               }
            else
                @start = _oa
            end
          end
        if !_o['end'].nil?
          _oa = _o['end']
            if(_oa.is_a? Hash)
              @end = EnunciateHelpers::LAMB_CLASS_AWARE.call(_oa) if _oa['@class']
              @end =  Time.from_json(_oa) unless _oa['@class']
            elsif (_oa.is_a? Array)
              #an array(of hashes hopefully) or scalar
              @end = Array.new
              _oa.each { | _item | 
                 if ((_item.nil? || _item['@class'].nil?)rescue true)
                   @end.push Time.from_json(_item)
                 else
                   @end.push EnunciateHelpers::LAMB_CLASS_AWARE.call(_item)
                 end
               }
            else
                @end = _oa
            end
          end
    end

    # constructs a Range from a (parsed) JSON hash
    def self.from_json(o)
      if o.nil?
        return nil
      else
        inst = new
        inst.init_jaxb_json_hash o
        return inst
      end
    end
  end

end

end

end

end

module Org

module Openvpms

module Booking

module Domain

  # (no documentation provided)
  class Booking 

    # the practice location identifier
    attr_accessor :location
    # the schedule identifier
    attr_accessor :schedule
    # the appointment type
    attr_accessor :appointmentType
    # the appointment start time
    attr_accessor :start
    # the appointment end time
    attr_accessor :end
    # the customer title
    attr_accessor :title
    # the customer first name
    attr_accessor :firstName
    # the customer last name
    attr_accessor :lastName
    # the customer email
    attr_accessor :email
    # the customer phone number. May be null
    attr_accessor :phone
    # the customer mobile number. May be null
    attr_accessor :mobile
    # the patient name
    attr_accessor :patientName
    # the notes. May be null
    attr_accessor :notes

    # the json hash for this Booking
    def to_jaxb_json_hash
      _h = {}
      _h['location'] = location.to_jaxb_json_hash unless location.nil?
      _h['schedule'] = schedule.to_jaxb_json_hash unless schedule.nil?
      _h['appointmentType'] = appointmentType.to_jaxb_json_hash unless appointmentType.nil?
      _h['start'] = start.to_jaxb_json_hash unless start.nil?
      _h['end'] = end.to_jaxb_json_hash unless end.nil?
      _h['title'] = title.to_jaxb_json_hash unless title.nil?
      _h['firstName'] = firstName.to_jaxb_json_hash unless firstName.nil?
      _h['lastName'] = lastName.to_jaxb_json_hash unless lastName.nil?
      _h['email'] = email.to_jaxb_json_hash unless email.nil?
      _h['phone'] = phone.to_jaxb_json_hash unless phone.nil?
      _h['mobile'] = mobile.to_jaxb_json_hash unless mobile.nil?
      _h['patientName'] = patientName.to_jaxb_json_hash unless patientName.nil?
      _h['notes'] = notes.to_jaxb_json_hash unless notes.nil?
      return _h
    end

    # the json (string form) for this Booking
    def to_json
      to_jaxb_json_hash.to_json
    end

    #initializes this Booking with a json hash
    def init_jaxb_json_hash(_o)
        if !_o['location'].nil?
          _oa = _o['location']
            if(_oa.is_a? Hash)
              @location = EnunciateHelpers::LAMB_CLASS_AWARE.call(_oa) if _oa['@class']
              @location =  Bignum.from_json(_oa) unless _oa['@class']
            elsif (_oa.is_a? Array)
              #an array(of hashes hopefully) or scalar
              @location = Array.new
              _oa.each { | _item | 
                 if ((_item.nil? || _item['@class'].nil?)rescue true)
                   @location.push Bignum.from_json(_item)
                 else
                   @location.push EnunciateHelpers::LAMB_CLASS_AWARE.call(_item)
                 end
               }
            else
                @location = _oa
            end
          end
        if !_o['schedule'].nil?
          _oa = _o['schedule']
            if(_oa.is_a? Hash)
              @schedule = EnunciateHelpers::LAMB_CLASS_AWARE.call(_oa) if _oa['@class']
              @schedule =  Bignum.from_json(_oa) unless _oa['@class']
            elsif (_oa.is_a? Array)
              #an array(of hashes hopefully) or scalar
              @schedule = Array.new
              _oa.each { | _item | 
                 if ((_item.nil? || _item['@class'].nil?)rescue true)
                   @schedule.push Bignum.from_json(_item)
                 else
                   @schedule.push EnunciateHelpers::LAMB_CLASS_AWARE.call(_item)
                 end
               }
            else
                @schedule = _oa
            end
          end
        if !_o['appointmentType'].nil?
          _oa = _o['appointmentType']
            if(_oa.is_a? Hash)
              @appointmentType = EnunciateHelpers::LAMB_CLASS_AWARE.call(_oa) if _oa['@class']
              @appointmentType =  Bignum.from_json(_oa) unless _oa['@class']
            elsif (_oa.is_a? Array)
              #an array(of hashes hopefully) or scalar
              @appointmentType = Array.new
              _oa.each { | _item | 
                 if ((_item.nil? || _item['@class'].nil?)rescue true)
                   @appointmentType.push Bignum.from_json(_item)
                 else
                   @appointmentType.push EnunciateHelpers::LAMB_CLASS_AWARE.call(_item)
                 end
               }
            else
                @appointmentType = _oa
            end
          end
        if !_o['start'].nil?
          _oa = _o['start']
            if(_oa.is_a? Hash)
              @start = EnunciateHelpers::LAMB_CLASS_AWARE.call(_oa) if _oa['@class']
              @start =  Time.from_json(_oa) unless _oa['@class']
            elsif (_oa.is_a? Array)
              #an array(of hashes hopefully) or scalar
              @start = Array.new
              _oa.each { | _item | 
                 if ((_item.nil? || _item['@class'].nil?)rescue true)
                   @start.push Time.from_json(_item)
                 else
                   @start.push EnunciateHelpers::LAMB_CLASS_AWARE.call(_item)
                 end
               }
            else
                @start = _oa
            end
          end
        if !_o['end'].nil?
          _oa = _o['end']
            if(_oa.is_a? Hash)
              @end = EnunciateHelpers::LAMB_CLASS_AWARE.call(_oa) if _oa['@class']
              @end =  Time.from_json(_oa) unless _oa['@class']
            elsif (_oa.is_a? Array)
              #an array(of hashes hopefully) or scalar
              @end = Array.new
              _oa.each { | _item | 
                 if ((_item.nil? || _item['@class'].nil?)rescue true)
                   @end.push Time.from_json(_item)
                 else
                   @end.push EnunciateHelpers::LAMB_CLASS_AWARE.call(_item)
                 end
               }
            else
                @end = _oa
            end
          end
        if !_o['title'].nil?
          _oa = _o['title']
            if(_oa.is_a? Hash)
              @title = EnunciateHelpers::LAMB_CLASS_AWARE.call(_oa) if _oa['@class']
              @title =  String.from_json(_oa) unless _oa['@class']
            elsif (_oa.is_a? Array)
              #an array(of hashes hopefully) or scalar
              @title = Array.new
              _oa.each { | _item | 
                 if ((_item.nil? || _item['@class'].nil?)rescue true)
                   @title.push String.from_json(_item)
                 else
                   @title.push EnunciateHelpers::LAMB_CLASS_AWARE.call(_item)
                 end
               }
            else
                @title = _oa
            end
          end
        if !_o['firstName'].nil?
          _oa = _o['firstName']
            if(_oa.is_a? Hash)
              @firstName = EnunciateHelpers::LAMB_CLASS_AWARE.call(_oa) if _oa['@class']
              @firstName =  String.from_json(_oa) unless _oa['@class']
            elsif (_oa.is_a? Array)
              #an array(of hashes hopefully) or scalar
              @firstName = Array.new
              _oa.each { | _item | 
                 if ((_item.nil? || _item['@class'].nil?)rescue true)
                   @firstName.push String.from_json(_item)
                 else
                   @firstName.push EnunciateHelpers::LAMB_CLASS_AWARE.call(_item)
                 end
               }
            else
                @firstName = _oa
            end
          end
        if !_o['lastName'].nil?
          _oa = _o['lastName']
            if(_oa.is_a? Hash)
              @lastName = EnunciateHelpers::LAMB_CLASS_AWARE.call(_oa) if _oa['@class']
              @lastName =  String.from_json(_oa) unless _oa['@class']
            elsif (_oa.is_a? Array)
              #an array(of hashes hopefully) or scalar
              @lastName = Array.new
              _oa.each { | _item | 
                 if ((_item.nil? || _item['@class'].nil?)rescue true)
                   @lastName.push String.from_json(_item)
                 else
                   @lastName.push EnunciateHelpers::LAMB_CLASS_AWARE.call(_item)
                 end
               }
            else
                @lastName = _oa
            end
          end
        if !_o['email'].nil?
          _oa = _o['email']
            if(_oa.is_a? Hash)
              @email = EnunciateHelpers::LAMB_CLASS_AWARE.call(_oa) if _oa['@class']
              @email =  String.from_json(_oa) unless _oa['@class']
            elsif (_oa.is_a? Array)
              #an array(of hashes hopefully) or scalar
              @email = Array.new
              _oa.each { | _item | 
                 if ((_item.nil? || _item['@class'].nil?)rescue true)
                   @email.push String.from_json(_item)
                 else
                   @email.push EnunciateHelpers::LAMB_CLASS_AWARE.call(_item)
                 end
               }
            else
                @email = _oa
            end
          end
        if !_o['phone'].nil?
          _oa = _o['phone']
            if(_oa.is_a? Hash)
              @phone = EnunciateHelpers::LAMB_CLASS_AWARE.call(_oa) if _oa['@class']
              @phone =  String.from_json(_oa) unless _oa['@class']
            elsif (_oa.is_a? Array)
              #an array(of hashes hopefully) or scalar
              @phone = Array.new
              _oa.each { | _item | 
                 if ((_item.nil? || _item['@class'].nil?)rescue true)
                   @phone.push String.from_json(_item)
                 else
                   @phone.push EnunciateHelpers::LAMB_CLASS_AWARE.call(_item)
                 end
               }
            else
                @phone = _oa
            end
          end
        if !_o['mobile'].nil?
          _oa = _o['mobile']
            if(_oa.is_a? Hash)
              @mobile = EnunciateHelpers::LAMB_CLASS_AWARE.call(_oa) if _oa['@class']
              @mobile =  String.from_json(_oa) unless _oa['@class']
            elsif (_oa.is_a? Array)
              #an array(of hashes hopefully) or scalar
              @mobile = Array.new
              _oa.each { | _item | 
                 if ((_item.nil? || _item['@class'].nil?)rescue true)
                   @mobile.push String.from_json(_item)
                 else
                   @mobile.push EnunciateHelpers::LAMB_CLASS_AWARE.call(_item)
                 end
               }
            else
                @mobile = _oa
            end
          end
        if !_o['patientName'].nil?
          _oa = _o['patientName']
            if(_oa.is_a? Hash)
              @patientName = EnunciateHelpers::LAMB_CLASS_AWARE.call(_oa) if _oa['@class']
              @patientName =  String.from_json(_oa) unless _oa['@class']
            elsif (_oa.is_a? Array)
              #an array(of hashes hopefully) or scalar
              @patientName = Array.new
              _oa.each { | _item | 
                 if ((_item.nil? || _item['@class'].nil?)rescue true)
                   @patientName.push String.from_json(_item)
                 else
                   @patientName.push EnunciateHelpers::LAMB_CLASS_AWARE.call(_item)
                 end
               }
            else
                @patientName = _oa
            end
          end
        if !_o['notes'].nil?
          _oa = _o['notes']
            if(_oa.is_a? Hash)
              @notes = EnunciateHelpers::LAMB_CLASS_AWARE.call(_oa) if _oa['@class']
              @notes =  String.from_json(_oa) unless _oa['@class']
            elsif (_oa.is_a? Array)
              #an array(of hashes hopefully) or scalar
              @notes = Array.new
              _oa.each { | _item | 
                 if ((_item.nil? || _item['@class'].nil?)rescue true)
                   @notes.push String.from_json(_item)
                 else
                   @notes.push EnunciateHelpers::LAMB_CLASS_AWARE.call(_item)
                 end
               }
            else
                @notes = _oa
            end
          end
    end

    # constructs a Booking from a (parsed) JSON hash
    def self.from_json(o)
      if o.nil?
        return nil
      else
        inst = new
        inst.init_jaxb_json_hash o
        return inst
      end
    end
  end

end

end

end

end

module Org

module Openvpms

module Booking

module Domain

  # (no documentation provided)
  class Location < Org::Openvpms::Booking::Domain::Resource 

    # the time zone
    attr_accessor :timeZone

    # the json hash for this Location
    def to_jaxb_json_hash
      _h = super
      _h['timeZone'] = timeZone.to_jaxb_json_hash unless timeZone.nil?
      return _h
    end

    #initializes this Location with a json hash
    def init_jaxb_json_hash(_o)
      super _o
        if !_o['timeZone'].nil?
          _oa = _o['timeZone']
            if(_oa.is_a? Hash)
              @timeZone = EnunciateHelpers::LAMB_CLASS_AWARE.call(_oa) if _oa['@class']
              @timeZone =  String.from_json(_oa) unless _oa['@class']
            elsif (_oa.is_a? Array)
              #an array(of hashes hopefully) or scalar
              @timeZone = Array.new
              _oa.each { | _item | 
                 if ((_item.nil? || _item['@class'].nil?)rescue true)
                   @timeZone.push String.from_json(_item)
                 else
                   @timeZone.push EnunciateHelpers::LAMB_CLASS_AWARE.call(_item)
                 end
               }
            else
                @timeZone = _oa
            end
          end
    end

    # constructs a Location from a (parsed) JSON hash
    def self.from_json(o)
      if o.nil?
        return nil
      else
        inst = new
        inst.init_jaxb_json_hash o
        return inst
      end
    end
  end

end

end

end

end

module Org

module Openvpms

module Booking

module Domain

  # (no documentation provided)
  class AppointmentType < Org::Openvpms::Booking::Domain::Resource 

    # the no. of slots
    attr_accessor :slots

    # the json hash for this AppointmentType
    def to_jaxb_json_hash
      _h = super
      _h['slots'] = slots.to_jaxb_json_hash unless slots.nil?
      return _h
    end

    #initializes this AppointmentType with a json hash
    def init_jaxb_json_hash(_o)
      super _o
        if !_o['slots'].nil?
          _oa = _o['slots']
            if(_oa.is_a? Hash)
              @slots = EnunciateHelpers::LAMB_CLASS_AWARE.call(_oa) if _oa['@class']
              @slots =  Fixnum.from_json(_oa) unless _oa['@class']
            elsif (_oa.is_a? Array)
              #an array(of hashes hopefully) or scalar
              @slots = Array.new
              _oa.each { | _item | 
                 if ((_item.nil? || _item['@class'].nil?)rescue true)
                   @slots.push Fixnum.from_json(_item)
                 else
                   @slots.push EnunciateHelpers::LAMB_CLASS_AWARE.call(_item)
                 end
               }
            else
                @slots = _oa
            end
          end
    end

    # constructs a AppointmentType from a (parsed) JSON hash
    def self.from_json(o)
      if o.nil?
        return nil
      else
        inst = new
        inst.init_jaxb_json_hash o
        return inst
      end
    end
  end

end

end

end

end

module Org

module Openvpms

module Booking

module Domain

  # (no documentation provided)
  class Schedule < Org::Openvpms::Booking::Domain::Resource 

    # the slot size, in minutes
    attr_accessor :slotSize

    # the json hash for this Schedule
    def to_jaxb_json_hash
      _h = super
      _h['slotSize'] = slotSize.to_jaxb_json_hash unless slotSize.nil?
      return _h
    end

    #initializes this Schedule with a json hash
    def init_jaxb_json_hash(_o)
      super _o
        if !_o['slotSize'].nil?
          _oa = _o['slotSize']
            if(_oa.is_a? Hash)
              @slotSize = EnunciateHelpers::LAMB_CLASS_AWARE.call(_oa) if _oa['@class']
              @slotSize =  Fixnum.from_json(_oa) unless _oa['@class']
            elsif (_oa.is_a? Array)
              #an array(of hashes hopefully) or scalar
              @slotSize = Array.new
              _oa.each { | _item | 
                 if ((_item.nil? || _item['@class'].nil?)rescue true)
                   @slotSize.push Fixnum.from_json(_item)
                 else
                   @slotSize.push EnunciateHelpers::LAMB_CLASS_AWARE.call(_item)
                 end
               }
            else
                @slotSize = _oa
            end
          end
    end

    # constructs a Schedule from a (parsed) JSON hash
    def self.from_json(o)
      if o.nil?
        return nil
      else
        inst = new
        inst.init_jaxb_json_hash o
        return inst
      end
    end
  end

end

end

end

end
